#$Header: /usr/cvs/lui/lui/lib/lim.pl,v 1.6 2001/07/12 22:02:59 lynnmoss Exp $

use vars qw(@ISA @EXPORT @EXPORT_OK);
use Exporter;
@ISA = qw(Exporter);

########################################################################
#
# Determine the Distribution:
#
# Valid distributions are:
# RedHat, MSC, SuSE
#
# Currently DISTRIB_SERVER = DISTRIB_CLIENT.
# Eventually we would like to allow these to
# be different.  For now, they must be the same.
#
# Use RedHat as default.
$DISTRIB_SERVER="RedHat";
$DISTRIB_CLIENT="RedHat";
#
# For MSC.Linux, use kernel (2.2.17-4.msc-up)
$KERNEL=`/bin/uname -r`;
if ($KERNEL =~ "msc") {
   $DISTRIB_SERVER="MSC";
   $DISTRIB_CLIENT="MSC";
}
# If SuSEconfig script exists, assume this is a SuSE distribution.
if (-e "/sbin/SuSEconfig") {
   $DISTRIB_SERVER="SuSE";
   $DISTRIB_CLIENT="SuSE";
  }

push(@EXPORT,"\$DISTRIB_SERVER");
push(@EXPORT,"\$DISTRIB_CLIENT");
########################################################################
#
# Be sure and add all definitions to @EXPORT so they are available to callers.
#
########################################################################

# Commands
$CHROOT="/usr/sbin/chroot"; 
	push(@EXPORT,"\$CHROOT");
$DATE="/bin/date"; 
	push(@EXPORT,"\$DATE");
$MKDIR="/bin/mkdir"; 
	push(@EXPORT,"\$MKDIR");
$RMDIR="/bin/rmdir"; 
	push(@EXPORT,"\$RMDIR");
$DIFF="/usr/bin/diff"; 
	push(@EXPORT,"\$DIFF");
$ECHO="/bin/echo"; 
	push(@EXPORT,"\$ECHO");
$RM="/bin/rm"; 
	push(@EXPORT,"\$RM");
$FIND="/usr/bin/find"; 
	push(@EXPORT,"\$FIND");
$LN="/bin/ln"; 
	push(@EXPORT,"\$LN");
$RSH="/usr/bin/rsh"; 
	push(@EXPORT,"\$RSH");
$FDISK="/sbin/fdisk"; 
	push(@EXPORT,"\$FDISK");
$PS="/bin/ps"; 
	push(@EXPORT,"\$PS");
$GREP="/bin/grep"; 
if ($DISTRIB_SERVER eq "MSC" || $DISTRIB_SERVER eq "SuSE") {
   $GREP="/usr/bin/grep"; 
   }
	push(@EXPORT,"\$GREP");
$UMASK="umask"; 
	push(@EXPORT,"\$UMASK");
$CHMOD="/bin/chmod"; 
	push(@EXPORT,"\$CHMOD");
$CP="/bin/cp"; 
	push(@EXPORT,"\$CP");
$MKE2FS="/sbin/mke2fs"; 
	push(@EXPORT,"\$MKE2FS");
$MKSWAP="/sbin/mkswap"; 
	push(@EXPORT,"\$MKSWAP");
$CAT="/bin/cat"; 
	push(@EXPORT,"\$CAT");
$LS="/bin/ls"; 
	push(@EXPORT,"\$LS");
$WC="/usr/bin/wc"; 
	push(@EXPORT,"\$WC");
$TAR="/bin/tar"; 
	push(@EXPORT,"\$TAR");
$MOUNT="/bin/mount"; 
	push(@EXPORT,"\$MOUNT");
$UMOUNT="/bin/umount"; 
	push(@EXPORT,"\$UMOUNT");
$LILO="/sbin/lilo"; 
	push(@EXPORT,"\$LILO");
$TOUCH="/bin/touch"; 
	push(@EXPORT,"\$TOUCH");
$SED="/bin/sed"; 
	push(@EXPORT,"\$SED");
$RDEV="/usr/sbin/rdev"; 
	push(@EXPORT,"\$RDEV");
$RPM="/bin/rpm"; 
	push(@EXPORT,"\$RPM");
$ARCH="/bin/arch"; 
	push(@EXPORT,"\$ARCH");
$DD="/bin/dd"; 
	push(@EXPORT,"\$DD");

# Directories & Files
$LIMDIR="/tftpboot/lim"; 
	push(@EXPORT,"\$LIMDIR");
$LIMLOG="/tftpboot/lim/log"; 
	push(@EXPORT,"\$LIMLOG");
$LIMTAR="/tftpboot/tar"; 
	push(@EXPORT,"\$LIMTAR");
$LIMRPM="/tftpboot/rpm"; 
	push(@EXPORT,"\$LIMRPM");
$LIM="/lim"; 
	push(@EXPORT,"\$LIM");
$MACINFO="/etc/MAC.info"; 
	push(@EXPORT,"\$MACINFO");
$PXELINUX="/tftpboot/pxelinux.cfg"; 
	push(@EXPORT,"\$PXELINUX");
$COMMON="/tftpboot/common"; 
	push(@EXPORT,"\$COMMON");
$Groupfile="$LIMDIR/LUIGroups";	# File that stores groups
	push(@EXPORT,"\$Groupfile");

@ROOTDIRS=("home", "mnt", "proc", "tmp", "usr", "lim", "boot", "tar", "lib", "sbin", "bin", "var", "dev", "root", "rpm"); 
if ($DISTRIB_CLIENT eq "MSC") {
	push(@ROOTDIRS,"webmin-0.80");
}
	push(@EXPORT,"\@ROOTDIRS");

@COMMONDIRS=("lib", "sbin", "bin", "dev", "root"); 
if ($DISTRIB_CLIENT eq "MSC") {
	push(@COMMONDIRS,"webmin-0.80");
}
	push(@EXPORT,"\@COMMONDIRS");

# Constants
$SERVER="server"; 
	push(@EXPORT,"\$SERVER");
$CLIENT="client"; 
	push(@EXPORT,"\$CLIENT");
$NFS_FILE="nfs"; 
	push(@EXPORT,"\$NFS_FILE");
$SWAP="swap"; 
	push(@EXPORT,"\$SWAP");
$EXT2_FILE="ext2"; 
	push(@EXPORT,"\$EXT2_FILE");
$EXTENDED="extended"; 
	push(@EXPORT,"\$EXTENDED");
$PPCBOOT="ppcboot"; 
	push(@EXPORT,"\$PPCBOOT");
$RW_FILE ="rw"; 
	push(@EXPORT,"\$RW_FILE");
$RO_FILE ="ro"; 
	push(@EXPORT,"\$RO_FILE");
$UNALL="all"; 
	push(@EXPORT,"\$UNALL");
$MAINT_MODE="maint"; 
	push(@EXPORT,"\$MAINT_MODE");
$INSTALL_MODE="install"; 
	push(@EXPORT,"\$INSTALL_MODE");
$DISK_MODE="disk"; 
	push(@EXPORT,"\$DISK_MODE");
%Groups;                       	# Group hash
	push(@EXPORT,"\%Groups");
$RGprefix="<LUIRG>"; 		# Prefix added to resource groups internally
	push(@EXPORT,"\$RGprefix");            	

# Hash of services to keep in the remote root filesystem
# if $KEEP_SERVICES{"ALL"} is defined, LUI doesn't remove any
push(@EXPORT,"\%KEEP_SERVICES");
if ($DISTRIB_CLIENT eq "RedHat") {
$KEEP_SERVICES{"functions"}=1;
$KEEP_SERVICES{"inet"}=1;
$KEEP_SERVICES{"netfs"}=1;
$KEEP_SERVICES{"network"}=1;
$KEEP_SERVICES{"nfs"}=1;
$KEEP_SERVICES{"nfslock"}=1;
$KEEP_SERVICES{"pcmcia"}=1;
$KEEP_SERVICES{"portmap"}=1;
$KEEP_SERVICES{"xinetd"}=1;
} elsif ($DISTRIB_CLIENT eq "MSC") {
$KEEP_SERVICES{"functions"}=1;
$KEEP_SERVICES{"localnet"}=1;
$KEEP_SERVICES{"inetd"}=1;
$KEEP_SERVICES{"mountfs"}=1;
$KEEP_SERVICES{"ethnet"}=1;
$KEEP_SERVICES{"nfsd"}=1;
$KEEP_SERVICES{"raid"}=1;
$KEEP_SERVICES{"checkfs"}=1;
$KEEP_SERVICES{"rcS"}=1;
$KEEP_SERVICES{"rc"}=1;
# $KEEP_SERVICES{"pcmcia"}=1; # Coming in a later release.
$KEEP_SERVICES{"portmap"}=1;
} elsif ($DISTRIB_CLIENT eq "SuSE") {
$KEEP_SERVICES{"boot"}=1;
$KEEP_SERVICES{"boot.d"}=1;
$KEEP_SERVICES{"boot.local"}=1;
$KEEP_SERVICES{"boot.setup"}=1;
$KEEP_SERVICES{"dhclient"}=1;
$KEEP_SERVICES{"dhcrelay"}=1;
$KEEP_SERVICES{"inetd"}=1;
$KEEP_SERVICES{"init.d"}=1;
$KEEP_SERVICES{"kerneld"}=1;
$KEEP_SERVICES{"luilocal"}=1;
$KEEP_SERVICES{"netfs"}=1;
$KEEP_SERVICES{"network"}=1;
$KEEP_SERVICES{"nfs"}=1;
$KEEP_SERVICES{"portmap"}=1;
$KEEP_SERVICES{"rc"}=1;
$KEEP_SERVICES{"rc0.d"}=1;
$KEEP_SERVICES{"rc1.d"}=1;
$KEEP_SERVICES{"rc2.d"}=1;
$KEEP_SERVICES{"rc3.d"}=1;
$KEEP_SERVICES{"rc4.d"}=1;
$KEEP_SERVICES{"rc5.d"}=1;
$KEEP_SERVICES{"rc6.d"}=1;
$KEEP_SERVICES{"rcS.d"}=1;
}

# Hash of all resource types and the string that matches
push(@EXPORT,"\%RESOURCE_TYPE");
$RESOURCE_TYPE{file}="file";
$RESOURCE_TYPE{disk}="disk";
$RESOURCE_TYPE{kernel}="kernel";
$RESOURCE_TYPE{exit}="exit";
$RESOURCE_TYPE{rpm}="rpm";
$RESOURCE_TYPE{map}="map";
$RESOURCE_TYPE{ramdisk}="ramdisk";
$RESOURCE_TYPE{source}="source";
$RESOURCE_TYPE{postinstall} = "postinstall";


sub allocated_resources(){
  local ($filename)=@_;
  if (! -f $filename) {
	return;
  }
  if (!open (ALLOCATE_TABLE, "<$filename")){
        print "Could not open the resource allocate table $filename, exiting\n";
        exit 1;
  }
  else{
        @locallist=<ALLOCATE_TABLE>;
        close ALLOCATE_TABLE;
        return @locallist;
  }
} 
push(@EXPORT,"\&allocated_resources");

sub read_resource_object(){
  local ($filename)=@_;
  if (!open (RESOURCE_OBJECT, "<$filename")){
        print "Could not open the resource object file $filename exiting\n";
        exit 1;
  }
  else{
        $localline=<RESOURCE_OBJECT>;
        close RESOURCE_OBJECT;
        return $localline;
  }
} 
push(@EXPORT,"\&read_resource_object");

sub read_rpm_table(){
  local ($filename)=@_;
  if (!open (RPM_TABLE, "<$filename")){
        print "Could not open the RPM table $filename, exiting\n";
        exit 1;
  }
  else{
        @locallist=<RPM_TABLE>;
        close RPM_TABLE;
        return @locallist;
  }
} 
push(@EXPORT,"\&read_rpm_table");


sub delete_bootp_entry (){
  local ($ha,$name)=@_;
  $line=`$GREP $ha /etc/bootptab`;
  if ($line eq ""){
	print "there is no bootp entry for client $name, nothing to remove there\n";
	return 0;
  }
  else {	
	print "before deleting the /etc/bootptab entry for $name, creating a backup at /etc/bootptab.lui.back, for your safety\n";
	`$SED /$ha/d /etc/bootptab > /tmp/$lui.$$`;
	if ($? != 0){
		print "error, could not delete the entry for MAC address $ha for client $name, exiting\n";
		return 1;
	}
        `$CP /etc/bootptab /etc/bootptab.lui.back`;
	`$CP /tmp/$lui.$$ /etc/bootptab`;
	if ($? != 0){
		print "error, could not replace the /etc/bootptab file with the new one, without client $name, exiting\n";
		return 1;
	}
	print "successfully deleted the bootptab entry for client $name\n";
  }
  return 0;
} 
push(@EXPORT,"\&delete_bootp_entry");


sub am_i_allocated{
local ($resource_name,$resource_type)=@_;
  $allocated=0;
  $machine_list="";
  @line=`cd $LIMDIR;$LS *.allocate_table 2>/dev/null`;
  foreach $line(@line){
	chop($line);
        @list=&allocated_resources("$LIMDIR/$line");
	foreach $item(@list){
		chop($item);
		($name,$type)=split(/:/,$item);
		($realname,$rest)=split(/\./,$name);
		if ($realname eq $resource_name && $type eq $resource_type){
			$allocated++;
			($machine,$machtype)=split(/\./,$line);
			$machine_list=$machine_list." ". $machine;
		}
        }
	
  }

  if ($allocated == 0){
	print "\nthis resource is not allocated\n";
  }
  else {
	print "\nthis resource is allocated by:\n";
	print "		$machine_list\n";
  }
  return 0;
} 
push(@EXPORT,"\&am_i_allocated");


sub write_client_obj{
  local ($name,$line)=@_;
  `$ECHO "$line" > $name`;
  if ($? != 0){
    print "error -- could not create client object, exiting\n";
    return 1;
  }
  return 0;
} 
push(@EXPORT,"\&write_client_obj");


sub add_bootp_entry{
  local($ip,$name,$gateway,$hostname,$netmask,$ha)=@_;
  if (`$GREP $ha /etc/bootptab 2>/dev/null` ne ""){
	print "error -- the MAC address $ha for client $name is already in use in the /etc/booptab file, exiting\n";
	return 1;
  }
  else{
	if ($gateway eq ""){
		$gate="";
	}
	else {
		$gate="gw=$gateway:";
	}
	chop($server_tmp=`cd $LIMDIR;$LS *.server`);
        ($server_fn,$rest)=split(/\./,$server_tmp);
	luiapi::lui_read_machine_object($server_fn,$SERVER);
	&assign_server_values($server_fn);
	$arch = `$ARCH`;
	chop($arch);
	if ($arch eq "ppc") {
		`$ECHO "$hostname:bf=/tftpboot/zImage.ppc:ip=$ip:ht=ethernet:ha=$ha:sa=$server_ipaddr:sm=$netmask:$gate" >> /etc/bootptab`;
	} else {
		`$ECHO "$hostname:bf=/tftpboot/vmlinuz:ip=$ip:ht=ethernet:ha=$ha:sa=$server_ipaddr:sm=$netmask:$gate" >> /etc/bootptab`;
	}
	if ($? != 0){
		print "error -- could not add an entry for $name to /etc/bootptab, exiting\n";
		return 1;
	}
  }
  print "successfully added an entry for $name in /etc/bootptab, continuing\n";
  return 0;
} 
push(@EXPORT,"\&add_bootp_entry");

sub assign_client_values{
  my ($name)=$_[0];
  $ip=$machineObject{$name}{$CLIENT}{IP};
  $netmask=$machineObject{$name}{$CLIENT}{NETMASK};
  $ha=$machineObject{$name}{$CLIENT}{HA};
  $mac_id=$machineObject{$name}{$CLIENT}{MAC_ID};
  $type=$machineObject{$name}{$CLIENT}{TYPE};
  $adapter=$machineObject{$name}{$CLIENT}{ADAPTER};
  $default=$machineObject{$name}{$CLIENT}{DEFROUTE};
  $hostname=$machineObject{$name}{$CLIENT}{HOSTNAME};
  $gateway=$machineObject{$name}{$CLIENT}{GATEWAY};
  $num_proc=$machineObject{$name}{$CLIENT}{NUM_PROC};
  $pbsstring=$machineObject{$name}{$CLIENT}{PBS_STRING};
  $reboot=$machineObject{$name}{$CLIENT}{REBOOT};
} 
push(@EXPORT,"\&assign_client_values");

sub assign_server_values{
  my ($name)=$_[0];
  $server_ipaddr=$machineObject{$name}{$SERVER}{IP};
  $server_netmask=$machineObject{$name}{$SERVER}{NETMASK};
  $server_numproc=$machineObject{$name}{$SERVER}{NUM_PROC};
  $server_pbsstring=$machineObject{$name}{$SERVER}{PBS_STRING};
  $server_reboot=$machineObject{$name}{$SERVER}{REBOOT};
} 
push(@EXPORT,"\&assign_server_values");

sub resource_exists { 
	# Check that a resource is defined to LUI
	my $resource=$_[0];
	foreach $type (values %RESOURCE_TYPE) {
		if (-f "$LIMDIR/$resource.$type") {
			return $type;
		}
	}
	return 0; 
} #resource_exists
push(@EXPORT,"\&resource_exists");

sub machine_exists { 
	# Check that a machine is defined to LUI
	my $machine=$_[0];
	if (-f "$LIMDIR/$machine.client") {
		return "client";
	}
	if (-f "$LIMDIR/$machine.server") {
		return "server";
	}
	return 0; 

} #machine_exists
push(@EXPORT,"\&machine_exists");

sub group_exists {
	my $ingroup=$_[0];
	my $group;
	foreach $group (sort keys %Groups) {
		if ($group eq $ingroup) {
			return "machine";
		} elsif  ($group eq $RGprefix.$ingroup){
			return "resource";
		}
	}
	return 0;
} #group_exists
push(@EXPORT,"\&group_exists");

sub unique {
	my $item,%unique;
	undef %unique;
	foreach $item (@_){
		$unique{$item}=1;
	}
	return (sort keys %unique);
}
push(@EXPORT,"\&unique");

sub bytype {
	($aname,$atype)=split(/:/,$a);
	($bname,$btype)=split(/:/,$b);
	$atype cmp $btype;
}
push(@EXPORT,"\&bytype");

sub bytypesrv {
	($aname,$atype)=split(/\./,$a);
	($bname,$btype)=split(/\./,$b);
	$atype cmp $btype;
}
push(@EXPORT,"\&bytypesrv");

1;
